
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <math.h>
#include <limits.h> 
#include <errno.h> 

#include "data.h"
#include "random_set.h"
#include "gen_random.h"


/****************************************************************************/
/*  sorting modwffs                                                         */
/****************************************************************************/


void swap_lits(modlit *l1,modlit *l2) {
  modlit * tmp;
  tmp=l1;
  l1=l2;
  l2=tmp;
}

void sort_modcl(modcl *mc)
{ modlit * tmp;
  if  (modlit_min(mc->modlits[2],mc->modlits[1])) {
    tmp=mc->modlits[2];
    mc->modlits[2]=mc->modlits[1];
    mc->modlits[1]=tmp;
  }
  if  (modlit_min(mc->modlits[1],mc->modlits[0])) {
    tmp=mc->modlits[1];
    mc->modlits[1]=mc->modlits[0];
    mc->modlits[0]=tmp;
  }
  if  (modlit_min(mc->modlits[2],mc->modlits[1])) {
    tmp=mc->modlits[2];
    mc->modlits[2]=mc->modlits[1];
    mc->modlits[1]=tmp;
  }
}

#ifdef SORT_ABSSIGN
int code_min(int c1,int c2){
  if (abs(c1)==abs(c2))
     return (int_sign(c1)<int_sign(c2));
  else 
     return (abs(c1)<abs(c2));
}
#else 
int code_min(int c1,int c2){
  return (c1<c2);
}
#endif

int modlit_equal(modlit *l1,modlit *l2) {
  if (l1->code!=l2->code) 
     return 0;
  else 
     if (prop_modlit(l1)) 
       return 1;
     else 
        return modcl_equal(l1->modcl,l2->modcl);
  }

int modcl_equal(modcl *c1,modcl *c2) {
  int i;
  for (i=0;i<3;i++) 
    if (! modlit_equal(c1->modlits[i],c2->modlits[i]))
      return 0;
  return 1;
} 


int modlit_min(modlit *l1,modlit *l2) {
  if (l1->code==l2->code) {
     if (prop_modlit(l1)) 
       return 0;
     else 
        return modcl_min(l1->modcl,l2->modcl);
  }
  else if (code_min(l1->code,l2->code))
    return 1;
  else 
    return 0;
}

int modcl_min(modcl *c1,modcl *c2) {
  int i;
  for (i=0;i<3;i++) 
    if (! modlit_equal(c1->modlits[i],c2->modlits[i]))
      return modlit_min(c1->modlits[i],c2->modlits[i]);
  return 0;
} 

/*         
int modlit_min(modlit *l1,modlit *l2) {
  if code_min(l1->code,l2->code) 
    return 1;
  else if (l1->code>l2->code) 
    return 0;
  else if (prop_modlit(l1)) 
    return 0;
  else 
    return modcl_min(l1->modcl,l2->modcl);
}
*/




/******************************************************
*******************************************************

            GENERATORS 

*******************************************************
*******************************************************

NOTA: queste routine sono solo un esempio, le ho fatte 
per verificare il funzionamento delle altre. 
Quello che bisogna fare sara' una funzione:

void rand_modwff_fill(modwff *w_p,int nvar,float prop_ratio)

w_p :       (puntatore a) modal wff da "riempire"
nvar:       numero di variabili proposizionali
prop_ratio: # letterali proposiz.
            ---------------------
              # letterali tot

ES:
  w_p=modwff_alloc(clause_num,hl_lit_num,ll_lit_num);
  modwff_fill(w_p,nvar,prop_ratio);
  ris=s5_satisfiable(w_p);

OPPURE:

  w_p=modwff_alloc(clause_num,hl_lit_num,l_llit_num);
  for(i=1;i<=ntest;i++) {
    modwff_fill(w_p,nvar,prop_ratio);
    ris=s5_satisfiable(w_p);
  }

******************************************************/


static void rand_mlit_fill(modlit *l_p,int varnum,float prop_prob,int depth){
  if (!depth) {
    modlit_set_code(l_p,randint(varnum)*randsign(0.5));
  } 
  else {
    modlit_set_code(l_p,randsign(0.5)*ISMODAL);
    rand_mcl_fill(modlit_get_modcl(l_p),varnum,prop_prob,depth-1);
  }
}

// ********************* repetitions admitted ********************* 
#ifdef MULTISET 
static void rand_mcl_fill(modcl *c_p,int varnum,float prop_prob,int depth)
{ 
 int i,j,tmp,range=varnum*(varnum-1)*(varnum-2),mod_cnt=0;
 int A[3];
 modlit *tmplits[3]={NULL,NULL,NULL};
 
 tmp=rand_get(range);
 num2array3(tmp,varnum,A);

 if (depth==0) {
   for (i=0;i<modcl_get_dim(c_p);i++) 
      modlit_set_code(modcl_get_modlit(c_p,i),randsign(0.5)*(1+rand_get(varnum)));
 }
 else   {
   for (i=0;i<modcl_get_dim(c_p);i++) {  
    if (randprob(prop_prob)) 
      modlit_set_code(modcl_get_modlit(c_p,i),randsign(0.5)*(1+rand_get(varnum)));  
    else 
      rand_mlit_fill(modcl_get_modlit(c_p,i),varnum,prop_prob,depth);
   }
 }
#ifdef SORTED
 sort_modcl(c_p); 
#endif
}
// ********************* repetitions admitted ********************* 
#else 
static void rand_mcl_fill(modcl *c_p,int varnum,float prop_prob,int depth)
{ 
 int i,tmp,range=varnum*(varnum-1)*(varnum-2);
 /* int j,mod_cnt=0; */
 int A[3];
 modlit *tmplits[3]={NULL,NULL,NULL};
 
 tmp=rand_get(range);
 num2array3(tmp,varnum,A);

 if (depth==0) {
   for (i=0;i<modcl_get_dim(c_p);i++) 
      modlit_set_code(modcl_get_modlit(c_p,i),randsign(0.5)*A[i]);
 }
 else   {
   for (i=0;i<modcl_get_dim(c_p);i++) {  
    if (randprob(prop_prob)) 
      modlit_set_code(modcl_get_modlit(c_p,i),randsign(0.5)*A[i]);  
    else {
      do {
      rand_mlit_fill(modcl_get_modlit(c_p,i),varnum,prop_prob,depth);
      tmplits[i]=modcl_get_modlit(c_p,i);
      }
      while( mlit1_sameatom(tmplits[i],tmplits[(i+1)%3]) || 
             mlit1_sameatom(tmplits[i],tmplits[(i+2)%3])); 
    }
   }
 }
#ifdef SORTED
 sort_modcl(c_p); 
#endif
}
#endif

void rand_modwff_fill(modwff *w_p,int varnum,float prop_prob,int depth)
{
 int i;
 w_p->nvars=varnum;
 for (i=0;i<modwff_get_dim(w_p);i++)
    rand_mcl_fill(modwff_get_modcl(w_p,i),varnum,prop_prob,depth);
}








