#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <math.h>
#include <limits.h> 
#include <errno.h> 

#include "data.h"
#include "random_set.h"
#include "gen_random.h"

/*#define PRINT_INTERMEDIATE*/
/*#define LISP_PRINT*/
/*#define CHECK_PARTIAL_ASSIGNMENTS*/
#define DEFAULT_SEED 0

/******************************************************
                     MAIN
******************************************************/
int main(int argc, char *argv[])
{ 
  int seed,depth,N,L;
  /* int DIM=10,HL_DIM=3,LL_DIM=3,tmp,ris,i,j,wffnum=3; */
  float P;
  modwff *mw;
  /* char answer[3]; */
  char out_syntax;
  char *path_string = (char*)malloc(30);
  char *file_string = (char*)malloc(40);

  FILE *OUTFILE;
  char* cfile_name="wff.c";
  char* prologfile_name="wff.pl";
  char* krisfile_name="wff.kris";

  if (argc<4) 
  { 
     printf("USAGE: generate <c|p|k> <clause> <var> <prop> <depth> <seed>\n");
     printf("where: c prints out KsatC syntax concepts\n");
     printf("       p prints out TA syntax concepts\n");
     printf("       k prints out KRIS syntax concepts\n");
     printf("\n\n");
     exit(0);
  }
  out_syntax = *argv[1];
  L = atoi(argv[2]);
  N = atoi(argv[3]);
#ifndef MULTISET
  if (N<3) {
    printf("ERROR: you cannot generate literal sets with N<3\n");
    exit(0);
  }
#endif
  P = ((float) atoi(argv[4]))/100.0;
  depth = atoi(argv[5]);
  
  seed = atoi(argv[6]); 
  if (seed == -1)
     seed = time(NULL);
  srandom((unsigned long) seed);

  if (argc<8)
    sprintf(path_string,"./");
  else
    sprintf(path_string,"%s/",argv[7]);


  mw=modwff_alloc(L,depth);

  rand_modwff_fill(mw,N,P,depth);
  
  switch (out_syntax) 
    {
    case 'p' : prologprint_modwff(stdout,mw); break;
    case 'c' : print_modwff(stdout,mw); break;
    case 'l' : lispprint_modwff(stdout,mw); break;
    case 'k' : krisprint_modwff(stdout,mw); break;
    default : 
      sprintf(file_string,"%s%s",path_string, cfile_name);
      OUTFILE = fopen(file_string, "w");
      print_modwff(OUTFILE,mw);
      fclose(OUTFILE);

      sprintf(file_string,"%s%s",path_string, prologfile_name);
      OUTFILE = fopen(file_string, "w");
      prologprint_modwff(OUTFILE,mw);
      fclose(OUTFILE);

      sprintf(file_string,"%s%s",path_string, krisfile_name);
      OUTFILE = fopen(file_string, "w");
      krisprint_modwff(OUTFILE,mw);
      fclose(OUTFILE);

      break;
    }

  return 0;
}





